unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CPort, ComCtrls, MPlayer, ExtCtrls;

type
  TForm1 = class(TForm)
    ComPort1: TComPort;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    MediaPlayer1: TMediaPlayer;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Label5: TLabel;
    procedure ComPort1RxChar(Sender: TObject; Count: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Out_Buffer:char;
implementation

{$R *.dfm}

uses
   MMSystem, Math;
const
   MCI_SETAUDIO = $0873;
   MCI_DGV_SETAUDIO_VOLUME = $4002;
   MCI_DGV_SETAUDIO_ITEM = $00800000;
   MCI_DGV_SETAUDIO_VALUE = $01000000;
   MCI_DGV_STATUS_VOLUME = $4019;
type
   MCI_DGV_SETAUDIO_PARMS = record
     dwCallback: DWORD;
     dwItem: DWORD;
     dwValue: DWORD;
     dwOver: DWORD;
     lpstrAlgorithm: PChar;
     lpstrQuality: PChar;
   end;
type
   MCI_STATUS_PARMS = record
     dwCallback: DWORD;
     dwReturn: DWORD;
     dwItem: DWORD;
     dwTrack: DWORD;
   end;

{Set Volume, range 0 - 1000}
procedure MPSetVolume(MP: TMediaPlayer; Volume: Integer) ;
var
   p: MCI_DGV_SETAUDIO_PARMS;
begin
   p.dwCallback := 0;
   p.dwItem := MCI_DGV_SETAUDIO_VOLUME;
   p.dwValue := Volume;
   p.dwOver := 0;
   p.lpstrAlgorithm := nil;
   p.lpstrQuality := nil;
   mciSendCommand(MP.DeviceID, MCI_SETAUDIO, MCI_DGV_SETAUDIO_VALUE or MCI_DGV_SETAUDIO_ITEM, Cardinal(@p)) ;
end;

{Get Volume, range 0 - 1000}
function MPGetVolume(MP: TMediaPlayer): Integer;
var
   p: MCI_STATUS_PARMS;
begin
   p.dwCallback := 0;
   p.dwItem := MCI_DGV_STATUS_VOLUME;
   mciSendCommand(MP.DeviceID, MCI_STATUS, MCI_STATUS_ITEM, Cardinal(@p)) ;
   Result := p.dwReturn;
end;

procedure TForm1.ComPort1RxChar(Sender: TObject; Count: Integer);
var InBuffer:array[0..1] of byte;
    ADC_Hi,ADC_lo:byte;
    ADCRes:word;
    volt:double;
begin
        ComPort1.Read(InBuffer,2);
        ADC_Hi:=InBuffer[0];
        ADC_Lo:=InBuffer[1];
        ADCRes:=(ADC_Hi shl 8) or ADC_Lo;
        Volt:=(5*ADCRes)/$3FF;
        edit1.Text:=FloatToStrF(Volt,ffFixed,3,2);
        Progressbar1.Position:=round((100*ADCRes)/$3FF);
        MPSetVolume(MediaPlayer1, ProgressBar1.Position*10) ;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
        Comport1.Open;
        MediaPlayer1.Close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
        Comport1.Close;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
       if CheckBox1.Checked then
        ComPort1.WriteStr('1')
       else
        ComPort1.WriteStr('2');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
If OpenDialog1.Execute then
  begin
   MediaPlayer1.FileName:=OpenDialog1.FileName;
   MediaPlayer1.Open;
  end;
end;

end.
